<?php
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    // Check if the reCAPTCHA response is set and not empty
    if (isset($_POST['g-recaptcha-response']) && !empty($_POST['g-recaptcha-response'])) {
        
        // The secret key provided by Google (for verification)
        $secretKey = '6LfllosqAAAAAJ-Z6U9raYP9owwLL5RsUns5A6ZJ'; // Your site secret key
        
        // Get the reCAPTCHA response token
        $recaptchaResponse = $_POST['g-recaptcha-response'];
        
        // Prepare data for verification with Google
        $verifyUrl = 'https://www.google.com/recaptcha/api/siteverify';
        $data = [
            'secret' => $secretKey,
            'response' => $recaptchaResponse,
        ];

        // Send the POST request to Google reCAPTCHA API for verification
        $options = [
            'http' => [
                'method' => 'POST',
                'header' => 'Content-type: application/x-www-form-urlencoded',
                'content' => http_build_query($data),
            ],
        ];
        $context = stream_context_create($options);
        $response = file_get_contents($verifyUrl, false, $context);

        // Decode the JSON response
        $responseKeys = json_decode($response, true);

        // Check if the validation was successful
        if ($responseKeys['success']) {
            echo 'reCAPTCHA validation successful!';
        } else {
            echo 'reCAPTCHA validation failed. Please try again.';
        }
    } else {
        echo 'No reCAPTCHA response received. Please complete the reCAPTCHA.';
    }
}
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>reCAPTCHA Example</title>
    <script src="https://www.google.com/recaptcha/api.js" async defer></script>
</head>
<body>
    <h2>reCAPTCHA Example</h2>
    <form action="" method="POST">
        <!-- Google reCAPTCHA Checkbox widget -->
        <div class="g-recaptcha" data-sitekey="6LfllosqAAAAAJ-Z6U9raYP9owwLL5RsUns5A6ZJ"></div>

        <!-- Submit Button -->
        <button type="submit">Submit</button>
    </form>
</body>
</html>
