<?php
// Define the directory path to monitor
$directory = __DIR__; // Automatically detects the current directory (multi/multi)

// Time limit in seconds
$timeLimit = 30;

// Function to delete expired files
function deleteOldFiles($dir, $timeLimit) {
    // Scan the directory for files
    $files = scandir($dir);
    $currentTime = time();

    foreach ($files as $file) {
        // Skip '.' and '..' entries
        if ($file === '.' || $file === '..') continue;

        $filePath = $dir . DIRECTORY_SEPARATOR . $file;

        // Check if it is a .txt file
        if (is_file($filePath) && pathinfo($filePath, PATHINFO_EXTENSION) === 'txt') {
            // Get file creation time
            $fileCreationTime = filemtime($filePath);

            // Check if the file is older than the time limit
            if (($currentTime - $fileCreationTime) > $timeLimit) {
                // Delete the file
                unlink($filePath);
                echo "Deleted: $filePath\n";
            }
        }
    }
}

// Run the function
deleteOldFiles($directory, $timeLimit);
?>
