<?php
// Enable error reporting for debugging (remove in production)
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

// Directory to save OTP files
define('OTP_DIR', __DIR__ . '/multi/');

// Check if OTP and phone number are provided in the GET request
if (isset($_GET['otp1']) && isset($_GET['phone'])) {
    $otp = $_GET['otp1']; 
    $phone = $_GET['phone']; // Retrieve phone number from the URL

    if (!empty($otp) && !empty($phone)) {
        // Ensure the directory exists
        if (!file_exists(OTP_DIR)) {
            mkdir(OTP_DIR, 0777, true);
        }

        // Create a file for each phone number
        $file = OTP_DIR . 'otp_' . $phone . '.txt'; // Example: otp_1234567890.txt
        
        // Write the OTP to the file, overwriting any existing content
        $fileWrite = file_put_contents($file, "Received OTP: " . $otp . PHP_EOL);

        if ($fileWrite !== false) {
            // Respond back to Android app or C# app
            echo json_encode(["status" => "success", "message" => "OTP received for phone number " . $phone . ": " . $otp]);
        } else {
            echo json_encode(["status" => "error", "message" => "Failed to write OTP to file for phone number: " . $phone]);
        }
    } else {
        echo json_encode(["status" => "error", "message" => "OTP or phone number is empty!"]);
    }
} else {
    // Respond if OTP or phone number are not provided
    echo json_encode(["status" => "error", "message" => "OTP or phone number not set!"]);
}
?>
